package com.winhc.config;

import org.frameworkset.elasticsearch.boot.BBossESStarter;
import org.frameworkset.elasticsearch.client.ClientInterface;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;

/**
 * 配置多个es集群
 * 指定多es数据源profile：multi-datasource
 */
@Configuration
public class MultiESSTartConfigurer {
    @Primary
    @Bean(initMethod = "start")
    @ConfigurationProperties("spring.elasticsearch.bboss.es6")
    public BBossESStarter bbossESStarterEs6(){
        return new BBossESStarter();
    }

    @Bean(initMethod = "start")
    @ConfigurationProperties("spring.elasticsearch.bboss.es5")
    public BBossESStarter bbossESStarterEs5(){
        return new BBossESStarter();
    }


    @Bean
    public ClientInterface bbossESClient(BBossESStarter bBossESStarter) {
        return bBossESStarter.getRestClient();
    }

}