package com.winhc.kafka.consumer;

import com.winhc.common.enums.CompanyEnum;
import com.winhc.service.RelationService;
import com.winhc.utils.CompanyUtils;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.springframework.context.annotation.Bean;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.listener.ConsumerAwareListenerErrorHandler;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @author π
 * @Description:人员合并
 * @date 2021/4/8 16:12
 */
@Slf4j
//@Service
@AllArgsConstructor
@Deprecated
public class KafkaConsumerPersonMerge {

    private final Map<String, RelationService> map;

    @KafkaListener(id = "${spring.kafka.topic_person_merge}"
            , topics = "${spring.kafka.topic_person_merge}"
            , groupId = "${spring.kafka.consumer.group-id}", containerFactory = "containerFactory", errorHandler = "KafkaConsumerPersonMerge")
    public void consumerCompanyNode(List<ConsumerRecord<?, ?>> records) {
        List<Map<String, Object>> list = CompanyUtils.mapPlusV1(records);
        this.map.get(CompanyEnum.TopicType.PERSON_MERGE.VALUE).save(list);
    }

    /**
     * 因为手动确认消费，若消费失败，记录重刷
     */
    @Bean("KafkaConsumerPersonMerge")
    public ConsumerAwareListenerErrorHandler dealError() {
        return (message, e, consumer) -> {
            System.out.println(message);
            return null;
        };
    }
}
